package comp;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.table.*;
import java.lang.reflect.*;

public class Window extends javax.swing.JFrame {

    private DefaultTreeModel model;
    private DefaultTableModel tmodel;
    
    public Window() {
        initComponents();
        
        DefaultMutableTreeNode root = display (this);
        model = new DefaultTreeModel (root);
        jTree1.setModel (model);
        
        tmodel = new DefaultTableModel (0, 2);
        jTable1.setModel (tmodel);
        
        String [] data = { "abc", "def"};
        tmodel.addRow (data);
    }
    
    private DefaultMutableTreeNode display (Component comp)
    {
        String s = comp.getName() + " : " + 
                   comp.getClass().getName();
        // System.out.println (s);
        
        MyObject obj = new MyObject ();
        obj.text = s;
        obj.comp = comp;
        
        DefaultMutableTreeNode node =
                new DefaultMutableTreeNode (obj);
        
        if (comp instanceof Container)
        {
            Container area = (Container) comp;
            int n = area.getComponentCount();
            for (int i = 0; i < n; i++)
            {
                DefaultMutableTreeNode t = 
                   display (area.getComponent(i));
                node.add (t);
            }
        }
        
        return node;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSplitPane1.setDividerLocation(200);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(jTable1);

        jSplitPane1.setRightComponent(jScrollPane2);

        jTree1.setName("strom"); // NOI18N
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane3.setViewportView(jTree1);

        jSplitPane1.setLeftComponent(jScrollPane3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 289, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
       TreePath [] items = evt.getPaths();
       for (TreePath path : items)
       {
           if (evt.isAddedPath (path))
           {
               DefaultMutableTreeNode node = 
                 (DefaultMutableTreeNode) 
                    path.getLastPathComponent ();
               setTitle (""+node);
               
               MyObject obj = 
                   (MyObject) node.getUserObject ();
               
               // obj.comp.setBackground (Color.green);
               // String [] data = { ""+obj.comp, ""};
               // tmodel.addRow (data);
               
               displayProperties (obj.comp);
           }
       }
           
    }//GEN-LAST:event_jTree1ValueChanged

    private void displayProperties (Object obj)
    {
        tmodel.setColumnCount (3);
        tmodel.setRowCount(0);
        
        Class cls = obj.getClass ();
        // import java.lang.reflect.*;
        Method [] methods = cls.getMethods ();
        
        for (Method m : methods)
            if (m.getName().startsWith ("get") &&
                m.getParameterCount () == 0)
            {
            String [] data = new String [3];
            data [0] = m.getName();
            data [1] = m.getReturnType().getName ();
            String result = "";
            try
            {
                result = "" + m.invoke (obj);
            }
            catch (Exception e)
            {
            }
            data [2] = result;
            tmodel.addRow (data);
        }
        
    }
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
